"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var check_node_1 = require("./shared/check-node");
// tslint:disable-next-line:variable-name
exports.Rule = check_node_1.createCheckNodeRule(checkNode, "Unexpected reject, return an error instead.");
function checkNode(node, _ctx) {
    if (ts.isPropertyAccessExpression(node) &&
        ts.isIdentifier(node.expression) &&
        node.expression.text === "Promise" &&
        node.name.text === "reject") {
        return { invalidNodes: [check_node_1.createInvalidNode(node, [])] };
    }
    return { invalidNodes: [] };
}
//# sourceMappingURL=noRejectRule.js.map